<?php
require_once(dirname(__FILE__).'/../../../config.php');
require_once($CFG->libdir . '/formslib.php');
require_once(dirname(__FILE__).'/sharedactv.php');
global $USER;

// Get basic details and check login and permissions
$course=sharedactv_get_magic_course();
$context=get_context_instance(CONTEXT_COURSE, $course->id);
require_login($course);
require_capability('format/sharedactv:view',$context);
require_capability('format/sharedactv:create',$context);

/** Form for creating activities. */
class sharedact_create_form extends moodleform {
    /** Form definition. */
    function definition() {
        $mform =& $this->_form;
        $renderer =& $mform->defaultRenderer();
        
        $mform->addElement('hidden','iagree',1);
        $mform->addElement('static','','',get_string('create_instructions','format_sharedactv'));
        
        $course=sharedactv_get_magic_course();

        $first=true;
        foreach(sharedactv_get_installed_module_names() as $moduletype) {
            $mform->addElement('radio', 'activitytype', $first ? get_string('activitytype', 'format_sharedactv') : '',
              get_string('modulename',$moduletype),$moduletype);
            if($first) {
                $mform->setDefault('activitytype',$moduletype);
                $first=false;
            }
        }
          
        $mform->addElement('text', 'activityname', get_string('activityname', 'format_sharedactv'));        
        $mform->addRule('activityname', get_string('missingactivityname', 'format_sharedactv'), 'required', null, 'client');
        $mform->addRule('activityname', get_string('invalidactivityname', 'format_sharedactv'), 'regex', '~(^.*\S.*$)|^$~');
        $mform->setType('activityname', PARAM_MULTILANG);
        
        $mform->addElement('htmleditor', 'summary', get_string('activitysummary', 'format_sharedactv'),
            array('course' => $course->id));
        $mform->addRule('summary', get_string('missingsummary', 'format_sharedactv'), 'required', null, 'client');
        $mform->setType('summary', PARAM_RAW);
        

        $this->add_action_buttons(true,get_string('create','format_sharedactv'));
    }
}

$mform = new sharedact_create_form('create.php');

if ($mform->is_cancelled()){
    // Back to index.php
    redirect('./');
} else if ($data = $mform->get_data()){
    // Create the activity and redirect to the invite screen
    $cmid=sharedactv_create_activity($data->activitytype,
        stripslashes(trim($data->activityname)),stripslashes(trim($data->summary)));
    sharedactv_log($course,'create',$cmid,'Name: '.stripslashes($data->activityname));        
    redirect('invite.php?activity='.$cmid.'&justcreated=1&user='.$USER->id);
} else if (optional_param('iagree',0,PARAM_INT)) {
    // Display the header...
    $strsharedactivities=get_string('formatsharedactv','format_sharedactv');
    $strcreate=get_string('create','format_sharedactv');
    $nav=array();
    $nav[]=array('name'=>$strcreate,'type'=>'misc');
    print_header($strcreate,$strcreate,build_navigation($nav));
    print '<div class="sa_mainbit">';
    print_heading_with_help($strcreate, 'create', 'format_sharedactv');
        
    // ...form...
    $mform->display();
    
    // ...and footer
    print '</div>';
    print_footer();
} else {
    // Display the agreement screen
    $nav=array();
    $stragree=get_string('agree_create_heading','format_sharedactv');
    $nav[]=array('name'=>$stragree,'type'=>'misc');
    print_header($stragree,$stragree,build_navigation($nav));
    print '<div class="sa_mainbit">';
    print '<div class="sa_agreeform">';
    print_heading($stragree);
    print_string('agree_create','format_sharedactv');
    $striagree=get_string('iagree_create','format_sharedactv');
    $strok=get_string('ok');
    print <<<END
    <form activity='create.php' method='post'><div>
    <div class="sa_agreecheckbox">
    <input type='checkbox' name='iagree' value='1' id='nowagreed' /> 
    <label for='nowagreed'>$striagree</label>
    </div> 
    <input id='agreebutton' type='submit' value='$strok' />
    </div></form>
    <script type='text/javascript'>
    var agreebutton=document.getElementById('agreebutton'),
        nowagreed=document.getElementById('nowagreed');
    
    agreebutton.disabled=true;
    nowagreed.onclick=function() {
        agreebutton.disabled=!nowagreed.checked;
    };
    </script></div>
END;
    
    print '</div>';
    print_footer();
}
?>