<?php
require_once(dirname(__FILE__).'/../../../config.php');
require_once($CFG->libdir . '/formslib.php');
require_once(dirname(__FILE__).'/sharedactv.php');
global $USER;

// Get basic details and check login and permissions
$course=sharedactv_get_magic_course();
$cmid=required_param('activity',PARAM_INT);
$userid=required_param('user',PARAM_INT);
$cm=get_record('course_modules','id',$cmid);

require_login($course,true,$cm);
$context=get_context_instance(CONTEXT_MODULE, $cmid);
require_capability('format/sharedactv:manage',$context);

// Does this have any participants?
$gotparticipants=count(sharedactv_get_participants($cmid,SHAREDACTV_ROLE_PARTICIPANT))>0;

if($userid==$USER->id) {
    $user=$USER;
} else {
    require_capability('format/sharedactv:viewother',$context);
    $user=get_record('user','id',$userid);
}

// Handle actions
if(isset($_POST['orly'])) { // TODO Replace with less tired meme
    // Check there aren't any participants
    if($gotparticipants) {
        error('Cannot delete activity with participants'); 
    }
    // Actually delete activity and go back to main page
    sharedactv_delete_activity($cm);    
    sharedactv_log($course,'delete',$cmid,$userid!=$USER->id ? 'As user: '.$userid : '');        
    redirect('./');
    exit;
} else if(isset($_POST['cancel'])) {
    redirect('./');
    exit;
}

// OK, no action yet, so just display the form

// Display the header...
$strdelete=get_string('delete');
$nav=array();
$nav[]=array('name'=>$strdelete,'type'=>'misc');
print_header($strdelete,$strdelete,build_navigation($nav,$cm));
sharedactv_ui_viewotherbar($user);    

print '<div class="sa_mainbit">';
print_heading_with_help($strdelete,'delete','format_sharedactv');

if($gotparticipants) {
    print_string('delete_gotparticipants','format_sharedactv',
        './invite.php?activity='.$cmid.'&amp;user='.$user->id);    
} else {
    print_string('delete_instructions','format_sharedactv');
    
    // ...the form...
    $strcancel=get_string('cancel');
    print <<<END
<form action="delete.php" method="post"><div>
<input type="hidden" name="activity" value="$cmid" />
<input type="hidden" name="user" value="$userid" />
<input type="submit" name="orly" value="$strdelete" />
<input type="submit" name="cancel" value="$strcancel" />
</div></form?
END;
}
    
// ...and footer
print '</div>';
print_footer();
?>