<?php
require_once(dirname(__FILE__).'/../../../config.php');
require_once($CFG->libdir . '/formslib.php');
require_once(dirname(__FILE__).'/sharedactv.php');
global $USER,$COURSE,$cmid,$userid;

// Get basic details and check login and permissions
$course=sharedactv_get_magic_course();
$COURSE=$course;
$cmid=required_param('activity',PARAM_INT);
$userid=required_param('user',PARAM_INT);
$cm=get_record('course_modules','id',$cmid);

require_login($course,true,$cm);
$context=get_context_instance(CONTEXT_MODULE, $cmid);
require_capability('format/sharedactv:manage',$context);

/** Form for creating activities. */
class sharedact_edit_form extends moodleform {
    /** Form definition. */
    function definition() {
        global $COURSE,$cmid,$userid;
        $mform =& $this->_form;
        $renderer =& $mform->defaultRenderer();
        
        $mform->addElement('hidden','activity',$cmid);
        $mform->addElement('hidden','user',$userid);
        
        $mform->addElement('static','','',get_string('edit_instructions','format_sharedactv'));
                  
        $mform->addElement('text', 'name', get_string('activityname', 'format_sharedactv'));        
        $mform->addRule('name', get_string('missingactivityname', 'format_sharedactv'), 'required', null, 'client');
        $mform->addRule('name', get_string('invalidactivityname', 'format_sharedactv'), 'regex', '~(^.*\S.*$)|^$~');
        $mform->setType('name', PARAM_MULTILANG);
        
        $mform->addElement('htmleditor', 'summary', get_string('activitysummary', 'format_sharedactv'),
            array('course' => $COURSE->id));
        $mform->addRule('summary', get_string('missingsummary', 'format_sharedactv'), 'required', null, 'client');
        $mform->setType('summary', PARAM_RAW);        

        $this->add_action_buttons(true);
    }
}

$mform = new sharedact_edit_form('edit.php');

if ($mform->is_cancelled()){
    // Back to index.php
    redirect('./');
} else if ($data = $mform->get_data()){
    sharedactv_set_activity_info($cmid,$data->name,$data->summary);
    sharedactv_log($course,'edit',$cmid,
        ($userid!=$USER->id ? 'As user: '.$userid : '').' Name: '.$data->name);        
    redirect('./');
} else {
    // Display the header...
    $strsharedactivities=get_string('formatsharedactv','format_sharedactv');
    $stredit=get_string('edit','format_sharedactv');
    $nav=array();
    $nav[]=array('name'=>$stredit,'type'=>'misc');
    print_header($stredit,$stredit,build_navigation($nav,$cm));
    print '<div class="sa_mainbit">';
    print_heading_with_help($stredit, 'edit', 'format_sharedactv');
    
    $info=sharedactv_get_activity_info($cmid);
    $mform->set_data($info);
        
    // ...form...
    $mform->display();
    
    // ...and footer
    print '</div>';
    print_footer();
}
?>