<?php
require_once(dirname(__FILE__).'/../../../config.php');
require_once(dirname(__FILE__).'/sharedactv.php');
global $USER;

$cmid=required_param('to',PARAM_INT);

define('SHAREDACTV_USERPREF_AGREED_VIEW','sharedactv-agreed-view');

require_login();

// Get basic details and check login and permissions
$course=sharedactv_get_magic_course();
$COURSE=$course;
$cm=get_record('course_modules','id',$cmid);
if(!$cm) {
    error("Unknown activity $cmid",'./');
}
$context=get_context_instance(CONTEXT_MODULE, $cmid);

require_login($course,true,$cm);

// Note this is not much of a restriction because they could go directly to
// the module which won't check this. We need to apply this restriction by not
// allowing people without that capability to be invited.
require_capability('format/sharedactv:view',$context);

// Is this a form submit?
if(optional_param('nowagreed',0,PARAM_INT)===1) {
    set_user_preference(SHAREDACTV_USERPREF_AGREED_VIEW,1);
}

// If they've agreed now, redirect to the activity
$info=sharedactv_get_activity_info($cmid);
$agreed=get_user_preferences(SHAREDACTV_USERPREF_AGREED_VIEW,0);
if(!$agreed) {
    $owners=sharedactv_get_participants($cmid,SHAREDACTV_ROLE_CREATOR);
    $agreed=array_key_exists($USER->id,$owners);
}
if($agreed) {
    sharedactv_log($course,'enter',$cmid);
    redirect($CFG->wwwroot.'/mod/'.$info->moduletype.'/view.php?id='.$cmid);
    exit;    
}

// Print the form for them to agree
$nav=array();
$stragree=get_string('agree_view_heading','format_sharedactv');
$nav[]=array('name'=>$info->name,'type'=>'module','link'=>
    'go.php?to='.$cmid);
$nav[]=array('name'=>$stragree,'type'=>'misc');
print_header($stragree,$stragree,build_navigation($nav));
print_heading($stragree);
print_string('agree_view','format_sharedactv');
$striagree=get_string('iagree_view','format_sharedactv');
$strok=get_string('ok');
print <<<END
<form activity='go.php' method='post'><div>
<input type='hidden' name='to' value='$cmid' />
<div class="sa_agreecheckbox">
<input type='checkbox' name='nowagreed' value='1' id='nowagreed' /> 
<label for='nowagreed'>$striagree</label>
</div> 
<input id='agreebutton' type='submit' value='$strok' />
</div></form>
<script type='text/javascript'>
var agreebutton=document.getElementById('agreebutton'),
    nowagreed=document.getElementById('nowagreed');

agreebutton.disabled=true;
nowagreed.onclick=function() {
    agreebutton.disabled=!nowagreed.checked;
};
</script>
END;

print_footer();
?>