<?php
require_once(dirname(__FILE__).'/../../../config.php');
require_once(dirname(__FILE__).'/sharedactv.php');

$course=sharedactv_get_magic_course();
$context=get_context_instance(CONTEXT_COURSE, $course->id);
require_login($course);

global $USER;

if(!empty($SESSION->format_sharedactv_viewother)) {
    $userid=$SESSION->format_sharedactv_viewother;
    require_capability('format/sharedactv:viewother',$context);
    if(!($user=get_record('user','id',$userid))) {
        error('Incorrect user ID');
    }        
} else {
    require_capability('format/sharedactv:view',$context);
    $user=$USER;
    $userid=0;
}

$strsharedactivities=get_string('formatsharedactv','format_sharedactv');
$strheading=get_string('heading','format_sharedactv',fullname($user));

$nav=array();
print_header($strsharedactivities,$strheading,build_navigation($nav));

if($userid) {
    sharedactv_ui_viewotherbar($user);
}


$activities=sharedactv_get_shared_activities($userid);

print '<div class="sa_intro">';
print '<p>'.get_string('intro','format_sharedactv');
helpbutton('availableactivities',get_string('availableactivities','format_sharedactv'),'format_sharedactv');
print '</p>';
if(class_exists('ouflags')) {
    require_once($CFG->dirroot.'/mod/oucontent/oucontent.php');
    global $SITE;
    
    print '<p>'.get_string('help','format_sharedactv',
        oucontent_get_olink($SITE->id,'Shared activities user guide')).'</p>';
}
print '</div>';

print '<h2 class="sa_first">'.get_string('creatorheading','format_sharedactv');
helpbutton('activities_created',get_string('creatorheading','format_sharedactv'),'format_sharedactv');
print '</h2>';

if(count($activities[SHAREDACTV_ROLE_CREATOR])===0) {
    print '<p class="sa_none">'.get_string('creatornone','format_sharedactv').'</p>';    
} else {
    print '<div class="sa_activitylist">';
    $stredit=get_string('edit');
    $strdelete=get_string('delete');
    $strchange=get_string('changeinvites','format_sharedactv');
    foreach($activities[SHAREDACTV_ROLE_CREATOR] as $activity) {
        $name=format_text($activity->name,FORMAT_MOODLE,(object)array(
            'para'=>false,'newlines'=>false));
        $cmid=$activity->id;
        $moduletype=$activity->moduletype;
        $moduledisplayname=get_string('modulename',$moduletype);
        $strsharedto=get_string('sharedto','format_sharedactv',$moduledisplayname);
        
        $participantlist=sharedactv_get_participants($cmid);
        $participantlist=$participantlist[SHAREDACTV_ROLE_PARTICIPANT];
        
        if(count($participantlist)===0) {
            $participants='<p>'.get_string('nobody').'</p>';
        } else {
            $participants='<ul>';
            $firstclass=' class="first"';
            foreach($participantlist as $participant) {
                $participants.='<li'.$firstclass.'><a href="'.$CFG->wwwroot.'/user/view.php?id='.
                    $participant->id.'">'.htmlspecialchars(fullname($participant)).'</a></li>';
                $firstclass='';
            }
            $participants.='</ul>';
        }
        
        $modcontext=get_context_instance(CONTEXT_MODULE,$cmid);        
        if(has_capability('format/sharedactv:manage',$modcontext)) {
            $mainbuttons=<<<END
<form method='get' action='edit.php'><div>
<input type='hidden' name='activity' value='$cmid' />
<input type='hidden' name='user' value='{$user->id}' />
<input type='submit' value='$stredit' />
</div></form>
<form method='get' action='delete.php'><div>
<input type='hidden' name='activity' value='$cmid' />
<input type='hidden' name='user' value='{$user->id}' />
<input type='submit' value='$strdelete' />
</div></form>
END;
            $invitebutton=<<<END
<div><form method='get' action='invite.php'><div>
<input type='hidden' name='activity' value='$cmid' />
<input type='hidden' name='user' value='{$user->id}' />
<input type='submit' value='$strchange' />
</div></form></div>
END;
        } else {
            $mainbuttons='';
            $invitebutton='';            
        }
        
        print <<<END
<div class='sa_activity'>

<div class='sa_main'>
<h3><a href='go.php?to=$cmid'><img src='{$CFG->modpixpath}/$moduletype/icon.gif' alt='$moduledisplayname' /> $name</a></h3>
<div class='sa_mainbuttons'>
$mainbuttons
</div>
</div>

<div class='sa_info'>
<h4>$strsharedto</h4>
$participants
$invitebutton
</div>

<div class='clearer'></div>
</div>
END;
    }
    print '</div>';
}

// We don't let somebody else viewing the user's page create activities for 
// them. Create always works to create your *own* activities
if(has_capability('format/sharedactv:create',$context) && !$userid) {
    print '<form method="get" action="create.php"><input type="submit" value="'.
        get_string('create','format_sharedactv').'" /></form>';
}

print '<h2>'.get_string('participantheading','format_sharedactv');
helpbutton('activities_invited',get_string('creatorheading','format_sharedactv'),'format_sharedactv');
print '</h2>';

if(count($activities[SHAREDACTV_ROLE_PARTICIPANT])===0) {
    print '<p>'.get_string('participantnone','format_sharedactv').'</p>';    
} else {
    print '<div class="sa_activitylist">';
    $strremoveme=get_string('removeme','format_sharedactv');
    foreach($activities[SHAREDACTV_ROLE_PARTICIPANT] as $activity) {
        $name=format_text($activity->name,FORMAT_MOODLE,(object)array(
            'para'=>false,'newlines'=>false));
        $cmid=$activity->id;
        $moduletype=$activity->moduletype;
        $moduledisplayname=get_string('modulename',$moduletype);
        $strownedby=get_string('ownedby','format_sharedactv',$moduledisplayname);
        
        $ownerlist=sharedactv_get_participants($cmid);
        $ownerlist=$ownerlist[SHAREDACTV_ROLE_CREATOR];
        
        if(count($ownerlist)===0) {
            $owners='<p>'.get_string('nobody').'</p>';
        } else {
            $owners='<ul>';
            $firstclass=' class="first"';
            foreach($ownerlist as $owner) {
                $owners.='<li'.$firstclass.'><a href="'.$CFG->wwwroot.'/user/view.php?id='.
                    $owner->id.'">'.htmlspecialchars(fullname($owner)).'</a></li>';
                $firstclass='';
            }
            $owners.='</ul>';
        }
        

        if(!$userid || has_capability('format/sharedactv:manage',$context)) {
            $leaveform="<form method='get' action='leave.php'><div>
<input type='hidden' name='activity' value='$cmid' />
<input type='hidden' name='user' value='{$user->id}' />
<input type='submit' value='$strremoveme' />
</div></form>";
        } else {
            $leaveform='';
        }
        print <<<END
<div class='sa_activity'>

<div class='sa_main'>
<h3><a href='go.php?to=$cmid'><img src='{$CFG->modpixpath}/$moduletype/icon.gif' alt='$moduledisplayname' /> $name</a></h3>
<div class='sa_mainbuttons'>
$leaveform
</div>
</div>

<div class='sa_info'>
<h4>$strownedby</h4>
$owners
</div>

<div class='clearer'></div>
</div>
END;
    }
    print '</div>';
}
 

if(has_capability('format/sharedactv:viewother',$context)) {
    print '<h2>'.get_string('viewother_heading','format_sharedactv').'</h2>';
    $strviewother=get_string('view');
    $strusername=get_string('username');
    $defaultusername=$userid ? $user->username : ''; 
    print <<<END
<form action="viewother.php" method="post"><div>
<label for="username">$strusername</label>
<input id="username" name="username" type="text" size="8" value="{$defaultusername}" /> 
<input type="submit" value="$strviewother" />
</div></form>
END;
}

print_footer();


//redirect($CFG->wwwroot.'/course/view.php?id='.$course->id);

?>