<?php
require_once(dirname(__FILE__).'/../../../config.php');
require_once($CFG->libdir . '/formslib.php');
require_once(dirname(__FILE__).'/sharedactv.php');
global $USER;

$cmid=required_param('activity',PARAM_INT);
$justcreated=optional_param('justcreated',0,PARAM_INT);
$userid=required_param('user',PARAM_INT);

// Get basic details and check login and permissions
$course=sharedactv_get_magic_course();
$COURSE=$course;
$cm=get_record('course_modules','id',$cmid);
if(!$cm) {
    error("Unknown activity $cmid",'./');
}
$context=get_context_instance(CONTEXT_MODULE, $cmid);

require_login($course,true,$cm);
require_capability('format/sharedactv:manage',$context);

if($userid==$USER->id) {
    $activityuser=$USER;
} else {
    require_capability('format/sharedactv:viewother',$context);
    $activityuser=get_record('user','id',$userid);
}

$info=sharedactv_get_activity_info($cmid);

$invitepageurl='invite.php?activity='.$cmid.'&user='.$userid.
    ($justcreated?'&justcreated=1':'');

$activityfields="<input type='hidden' name='activity' value='$cmid' />
<input type='hidden' name='user' value='$userid' />".
    ($justcreated?'<input type="hidden" name="justcreated" value="1" />':'');

function get_email($info,$targetname,$emailtype) {
    global $USER,$CFG;
    $info->victim=$targetname;
    $info->creator=fullname($USER);
    $info->url=$CFG->wwwroot.'/course/format/sharedactv/go.php?to='.$info->id;
    $info->sitename=get_site()->shortname;
    $info->nametext=format_string($info->name,true);
    $info->summarytext=format_text_email(trusttext_strip($info->summary),FORMAT_HTML);
    $email->subject=get_string($emailtype.'_email_subject','format_sharedactv',$info);
    $email->body=trim(get_string($emailtype.'_email_body','format_sharedactv',$info));
    $email->preview="<h3>{$email->subject}</h3>{$email->body}";
    return $email;
}

if($_SERVER['REQUEST_METHOD']==='POST'){
    $action=required_param('action',PARAM_ALPHA);
    if($action=='add' || $action=='noreallyadd') {
        if(isset($_POST['cancel'])) {
            redirect($invitepageurl);
        }
        $add=stripslashes(required_param('add',PARAM_RAW));    
        // Split names on spaces and commas
        $names=preg_split('~[\s,]+~',strtolower($add),-1,PREG_SPLIT_NO_EMPTY);
        if(count($names)===0) {
            redirect($invitepageurl.'&donesomething=4');
            exit;
        }
        $names=array_unique($names);
        // Get participants list
        $participants=sharedactv_get_participants($cmid);
        $existingids=array();
        foreach($participants as $subarray) {
            foreach($subarray as $someuserid=>$whatever) {
                $existingids[$someuserid]=true;
            }
        }
        // Search for each name and see if any are missing or don't exist
        $users=array();
        $failed=array();
        $badname=false; 
        $existingname=false;
        foreach($names as $key=>$name) {
            if(!$user=get_record('user','username',addslashes($name))) {
                $badname=true;
                $failed[]=$name;
                continue;
            }
            if(array_key_exists($user->id,$existingids)) {
                $existingname=true;
                $failed[]=$name;
                unset($names[$key]);
                continue;
            }
            if(!has_capability('format/sharedactv:view',$context,$user->id)) {
                $banned=true;
                $failed[]=$name;
                unset($names[$key]);
                continue;
            }
            $users[]=$user;
        }
        if(count($failed)>0) {
            redirect($invitepageurl.'&donesomething='.
                ($badname ? 2 : ($banned ? 5: 3)).'&add='.implode('%20',$names).'&failed='.
                implode(', ',$failed));
            exit;            
        }
        
        // OK, we now have a valid list of users to add. Are we really adding them?
        if($action==='noreallyadd') {
            // Yep, we're really adding them
            $sent=array();
            $notsent=array();
            $invitedlist='';
            foreach($users as $user) {
                // Add participant
                sharedactv_add_participant($cmid,$user->id);
                $invitedlist.=$user->id.' ';
                
                // Send the email!
                $email=get_email($info,fullname($user),'invite');
                if(email_to_user(
                    $user,$USER,$email->subject,$email->body)===true) {
                    $sent[]=$user;
                } else {
                    $notsent[]=$user;
                }                    
            }
            
            sharedactv_log($course,'invite',$cmid,
                ($userid!=$USER->id ? 'As user: '.$userid : '').' Members: '.
                trim($invitedlist));                    
            
            // Display the header...
            $strsharedactivities=get_string('formatsharedactv','format_sharedactv');
            $strinvite=get_string('changeinvites','format_sharedactv');
            $strsent=get_string('sentinvitations','format_sharedactv');
            $nav=array();
            $nav[]=array('name'=>$info->name,'type'=>'module','link'=>
              'go.php?to='.$cmid);
            $nav[]=array('name'=>$strinvite,'type'=>'misc','link'=>
              $invitepageurl);
            $nav[]=array('name'=>$strsent,'type'=>'misc');
            print_header($strsent,$strsent,build_navigation($nav));
            sharedactv_ui_viewotherbar($activityuser);
            print '<div class="sa_mainbit">';
            print_heading($strsent);
            
            // Show the information about emails that were sent and that 
            // weren't
            if(count($sent)>0) {
                print '<p>'.get_string('invite_sentto','format_sharedactv').'</p><ul>';
                foreach($sent as $user) {
                    print '<li>'.fullname($user). ' ('.htmlspecialchars($user->username).')</li>';
                }
                print '</ul>';                
            }
            if(count($notsent)>0) {
                print '<p>'.get_string('invite_notsentto','format_sharedactv').'</p><ul>';
                foreach($notsent as $user) {
                    print '<li>'.fullname($user). ' ('.htmlspecialchars($user->username).')</li>';
                }
                print '</ul>';                
            }
            if($justcreated) {
                // Button goes into activity
                print '<form action="go.php" method="get"><input type="hidden" name="to" value="'.$cmid.'" />
                    <input type="submit" value="'.get_string('continuetoactivity','format_sharedactv').'" />
                    </form>';                
            } else {
                // Button goes back to invite page
                print '<form action="invite.php" method="get">'.
                    $activityfields.'
                    <input type="submit" value="'.get_string('returntoinvite','format_sharedactv').'" />
                    </form>';
            }
        } else {
            // This is just the preview/check page
            
            // Display the header...
            $strsharedactivities=get_string('formatsharedactv','format_sharedactv');
            $strinvite=get_string('changeinvites','format_sharedactv');
            $strconfirmadd=get_string('confirmadd','format_sharedactv');
            $strcancel=get_string('cancel');
            $nav=array();
            $nav[]=array('name'=>$info->name,'type'=>'module','link'=>
              'go.php?to='.$cmid);
            $nav[]=array('name'=>$strinvite,'type'=>'misc','link'=>
              $invitepageurl);
            $nav[]=array('name'=>$strconfirmadd,'type'=>'misc');
            print_header($strconfirmadd,$strconfirmadd,build_navigation($nav));
            sharedactv_ui_viewotherbar($activityuser);
            print '<div class="sa_mainbit">';
            print_heading($strconfirmadd);
            
            // Show the initial information
            print_string('inviteconfirm_instructions','format_sharedactv');
            print '<ul>';
            foreach($users as $user) {
                print '<li>'.fullname($user).
                    ' ('.htmlspecialchars($user->username).')</li>';
            }
            $email=get_email($info,fullname(reset($users)),'invite');
            print <<<END
</ul>
<pre>
{$email->preview}
</pre>
<form method='POST' action='invite.php'><div>
$activityfields
<input type='hidden' name='action' value='noreallyadd' />
<input type='hidden' name='add' value='$add' />
<input type='submit' value='$strconfirmadd' />
<input type='submit' name='cancel' value='$strcancel' />
</div></form>
END;
        }    
        print '</div>';    
        print_footer();
        exit;
     }
     if($action==='remove' || $action==='noreallyremove') {
         // Check and clean parameter
         if(!array_key_exists('remove',$_POST) || !is_array($_POST['remove'])) {
             redirect($invitepageurl.'&donesomething=11');
         }
         if(isset($_POST['cancel'])) {
            redirect($invitepageurl);
         }
         $remove=$_POST['remove'];
         $removedatahtml='';
         foreach($remove as $someuserid) {
             if(!preg_match('/^[0-9]+$/',$someuserid)) {
                 error('Remove parameter has incorrect format',$invitepageurl);
             }
             $removedatahtml.='<input type="hidden" name="remove[]" value="'.$someuserid.'" />';
         }
         
         // Get participants list and check everyone is in it
         $participants=sharedactv_get_participants($cmid);
         $existingids=array();
         $participants=$participants[SHAREDACTV_ROLE_PARTICIPANT];
         $users=array();
         foreach($remove as $someuserid) {
            if(!array_key_exists($someuserid,$participants)) {
                error('Requested user '.$someuserid.' is not a participant',$invitepageurl);
            }
            $users[$someuserid]=get_record('user','id',$someuserid);
         }
        
         // Right, parameters are ok
         if($action==='noreallyremove') {
            // Yep, we're really removing them
            $sent=array();
            $notsent=array();
            $removedlist='';
            foreach($users as $user) {
                // Add participant
                sharedactv_remove_participant($cmid,$user->id);
                $removedlist.=$user->id.' ';
                
                // Send the email!
                $email=get_email($info,fullname($user),'remove');
                if(email_to_user(
                    $user,$USER,$email->subject,$email->body)===true) {
                    $sent[]=$user;
                } else {
                    $notsent[]=$user;
                }                    
            }            
            sharedactv_log($course,'remove',$cmid,
                ($userid!=$USER->id ? 'As user: '.$userid : '').' Members: '.
                trim($removedlist));
                                    
            // Display the header...
            $strsharedactivities=get_string('formatsharedactv','format_sharedactv');
            $strinvite=get_string('changeinvites','format_sharedactv');
            $strsent=get_string('removed','format_sharedactv');
            $nav=array();
            $nav[]=array('name'=>$info->name,'type'=>'module','link'=>
              'go.php?to='.$cmid);
            $nav[]=array('name'=>$strinvite,'type'=>'misc','link'=>
              $invitepageurl);
            $nav[]=array('name'=>$strsent,'type'=>'misc');
            print_header($strsent,$strsent,build_navigation($nav));
            sharedactv_ui_viewotherbar($activityuser);
            print '<div class="sa_mainbit">';
            print_heading($strsent);
            
            // Show the information about emails that were sent and that 
            // weren't
            if(count($sent)>0) {
                print '<p>'.get_string('remove_sentto','format_sharedactv').'</p><ul>';
                foreach($sent as $user) {
                    print '<li>'.fullname($user). ' ('.htmlspecialchars($user->username).')</li>';
                }
                print '</ul>';                
            }
            if(count($notsent)>0) {
                print '<p>'.get_string('remove_notsentto','format_sharedactv').'</p><ul>';
                foreach($notsent as $user) {
                    print '<li>'.fullname($user). ' ('.htmlspecialchars($user->username).')</li>';
                }
                print '</ul>';                
            }
            print '<form action="invite.php" method="get">'.$activityfields.'
                <input type="submit" value="'.get_string('continue').'" />
                </form>';

         } else {
            // This is just the confirmation page
            
            // Display the header...
            $strsharedactivities=get_string('formatsharedactv','format_sharedactv');
            $strinvite=get_string('changeinvites','format_sharedactv');
            $strremove=get_string('remove','format_sharedactv');
            $strconfirmremove=get_string('confirmremove','format_sharedactv');
            $strcancel=get_string('cancel');
            $nav=array();
            $nav[]=array('name'=>$info->name,'type'=>'module','link'=>
              'go.php?to='.$cmid);
            $nav[]=array('name'=>$strinvite,'type'=>'misc','link'=>
              $invitepageurl);
            $nav[]=array('name'=>$strconfirmremove,'type'=>'misc');
            print_header($strconfirmremove,$strconfirmremove,build_navigation($nav));
            sharedactv_ui_viewotherbar($activityuser);
            print '<div class="sa_mainbit">';
            print_heading($strconfirmremove);
            
            // Show the initial information
            print_string('removeconfirm_instructions','format_sharedactv');
            print '<ul>';
            foreach($users as $user) {
                print '<li>'.fullname($user).
                    ' ('.htmlspecialchars($user->username).')</li>';
            }
            $email=get_email($info,fullname(reset($users)),'remove');            
            print <<<END
</ul>
<pre>
{$email->preview}
</pre>
<form method='POST' action='invite.php'><div>
$activityfields
<input type='hidden' name='action' value='noreallyremove' />
$removedatahtml
<input type='submit' value='$strconfirmremove' />
<input type='submit' name='cancel' value='$strcancel' />
</div></form>
END;
        }
        print '</div>';
        print_footer();
        exit;
     }
    
} else {
    // Display the main UI
    $donesomething=optional_param('donesomething',0,PARAM_INT);
    $add=optional_param('add','',PARAM_CLEAN);
    $failed=optional_param('failed','',PARAM_CLEAN);
    
    // Display the header...
    $strsharedactivities=get_string('formatsharedactv','format_sharedactv');
    $strinvite=get_string('changeinvites','format_sharedactv');
    $nav=array();
    $nav[]=array('name'=>$info->name,'type'=>'module','link'=>
      'go.php?to='.$cmid);
    $nav[]=array('name'=>$strinvite,'type'=>'misc');
    print_header($strinvite,$strinvite,build_navigation($nav));
    sharedactv_ui_viewotherbar($activityuser);
    print '<div class="sa_mainbit">';
    print_heading_with_help($strinvite, 'invite', 'format_sharedactv');
    
    // Display message if some action was already taken
    if($donesomething) {
        $a->url=$CFG->wwwroot.'/course/format/sharedactv/';
        $strbacktocourse=get_string('backtocourse','format_sharedactv');
        $strdonesomething=get_string('donesomething'.$donesomething,'format_sharedactv');
        $failmessage=$failed ? get_string('failed','format_sharedactv',$failed) : '';
        $backlink=$donesomething==1 ? "(<a href='./'>$strbacktocourse</a>.)" : ''; 
        print <<<END
<div class="sa_donesomething">
<p>
$strdonesomething $failmessage $backlink
</p>
</div>
END;
    }
    
    // Get list of already existing people
    $existing=sharedactv_get_participants($cmid);
    $existing=$existing[SHAREDACTV_ROLE_PARTICIPANT];
    
    if(count($existing)>0) {
        $strexisting=get_string('existing','format_sharedactv');
        $strremove=get_string('remove');
        $options='';
        foreach($existing as $user) {
            $name=fullname($user).' ('.$user->username.')';
            $options.="<option value='{$user->id}'>$name</option>";
        }
        print <<<END
<div class="sa_existing">
<h3>$strexisting</h3>
<form method="post" action="invite.php"><div>
$activityfields
<input type='hidden' name='action' value='remove' />
<select name='remove[]' multiple='multiple' size='14'>
$options
</select>
</div>
<div class='sa_block'>
<input type='submit' value='$strremove' />
</div>
</form>
</div>
END;
    }
    
    $strexplanation=get_string('invite_instructions','format_sharedactv',
        $justcreated ? get_string('invite_instructions_firsttime','format_sharedactv'):'');
    $strcancel=get_string('cancel');
    $strusernames=get_string('usernames','format_sharedactv');
    $extraclass=count($existing)==0 ? ' sa_nonames' : '';
    $strnew=get_string('new','format_sharedactv');
    $optionalheading=count($existing)===0 ? '' : '<h3>'.$strnew.'</h3>';
    print <<<END
<div class="sa_new$extraclass">
$optionalheading
$strexplanation
<form method="post" action="invite.php"><div>
$activityfields
<input type='hidden' name='action' value='add' />
<div class="sa_block">
<label class="accesshide" for="add">$strusernames</label> 
<textarea id="add" name='add' rows='5' cols='40'>$add</textarea>
</div>
<div><input type='submit' value='$strnew' /></div>
</div></form>
<form method="get" action="./"><div>
<div><input type='submit' value='$strcancel' /></div>
</div></form>
</div>
<div class="clearer"></div>
END;

		// Link back to course
		$strreturn=get_string('backtocourse','format_sharedactv');
		

    print '<div class="sa_linkback">'.link_arrow_left($strreturn,$CFG->wwwroot.
        '/course/format/sharedactv/').'</div>';
    
    // ...and footer
    print '</div>';
    print_footer();
}
?>