<?php
/**
 * Language strings for shared activities system.
 *
 * @copyright &copy; 2007 The Open University
 * @author S.Marshall@open.ac.uk
 * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
 * @package sharedactivities
 *//** */

// Name strings used in other bits of Moodle
$string['formatsharedactv']='Shared activities';
$string['fullname']='Shared activity course (do not modify!)';
$string['heading']='$a\'s personal collaboration area';
$string['heading_unknown']='Personal collaboration area';
$string['sharedactv_participant']='Shared activity participant';
$string['sharedactv_participant_desc']='<strong>Do not delete!</strong> These permissions apply to a participant in shared activities, within the activity to which they have been given access.';
$string['sharedactv_creator']='Shared activity creator';
$string['sharedactv_creator_desc']='<strong>Do not delete!</strong> These permissions apply to somebody who has created their own shared activity, within that activity.';

$string['creatorheading']='Your shared activities';
$string['creatornone']='You have not created any shared activities.';
$string['create']='Create new activity';
$string['sharedto']='<strong>$a</strong> shared to:';
$string['ownedby']='<strong>$a</strong> owned by:';
$string['removeme']='Leave this activity';
$string['changeinvites']='Add or remove members';
$string['participantheading']='Other people\'s activities that you can access';
$string['participantnone']='Nobody has invited you to any shared activities.';
$string['viewother_heading']='Other people\'s activities';
$string['viewing']='You are currently viewing activities for <strong>$a</strong>.';
$string['backtome']='Return to your own';

$string['create_instructions']='<p>
Creating a shared activity is a two-step process.
</p>
<ol>
<li>On this screen you set up the activity itself.</li>
<li>On the next screen you will invite people to use it.</li>
</ol>  
<p>
To get started, select the type of activity you\'d like to create, then give it 
a name and a summary so that the people you invite know what it\'s for.
(Both name and summary will be included in the invitation email.)
</p>';
$string['activitytype']='Activity type';
$string['activityname']='Activity name';
$string['missingactivityname']='A name is required.';
$string['invalidactivityname']='The name must contain visible characters such as letters.';
$string['activitysummary']='Summary';
$string['missingsummary']='Please use this space to describe the purpose of the activity to those who will use it.';

$string['invite_instructions']='<p>
To invite people, enter their usernames in the box below.
</p>
<ul>
<li>To get somebody\'s username, you need to ask them personally. This is the
name (not the password!) that they use to log in to the system.</li>
$a
</ul>
<p>
The system will automatically send an email to each person, with information 
and a link to this activity.
</p>
';
$string['invite_instructions_firsttime']='
<li>It\'s possible to add more names, or remove them, at a later date.</li>
';
$string['backtocourse']='Return to shared activities page';
$string['donesomething1']='The selected people have been added.';
$string['donesomething2']='Some usernames were not correct. Please check with the people concerned that you have their correct usernames.';
$string['donesomething3']='Some usernames were already listed as members. Please try again.';
$string['donesomething4']='No usernames entered. Please enter a list of usernames, separated by space.';
$string['donesomething5']='One or more of the people you entered do not have access to view shared activities.';
$string['donesomething11']='No members selected. Please select members from the list (use Ctrl-click, or &#x2318;-click for Mac users, to select more than one) before clicking Remove.';
$string['failed']='The following usernames caused problems: $a.';
$string['existing']='Existing members';
$string['new']='Invite new members';
$string['usernames']='Usernames to invite';
$string['confirmadd']='Confirm invitation';
$string['continuetoactivity']='Continue to activitiy';
$string['returntoinvite']='Return to member list';
$string['inviteconfirm_instructions']='
<p>
This is the list of people you\'re inviting, along with the email that
will be sent to them.
</p>
';
$string['invite_email_subject']='{$a->sitename}: Invitation to take part in a shared activity';
$string['invite_email_body']='
(This is an automated message. Please do not reply.)

{$a->victim},

{$a->creator} has invited you to take part in a shared activity 
\'{$a->nametext}\'.

If you want to access the activity, click the following link:
{$a->url}

If you don\'t want to access it, you can ignore this email.

Activity summary:

{$a->summarytext}
';
$string['sentinvitations']='Invitations sent';
$string['invite_sentto']='Invitation emails have been sent to the following people:';
$string['invite_notsentto']='For technical reasons, we were unable to send all the invitation emails. You will need to let the following people know about the activity yourself:';
$string['confirmremove']='Confirm remove';
$string['removeconfirm_instructions']='
<p>
You have requested that the following people be removed from the activity. 
Once removed, they will no longer be able to access it. They will be sent an
email (shown below) to inform them of this change.  
</p>';
$string['remove_email_subject']='{$a->sitename}: Removed from shared activity';
$string['remove_email_body']='
(This is an automated message. Please do not reply.)

{$a->victim},

{$a->creator} has removed you from the shared activity 
\'{$a->nametext}\'.

You will no longer be able to access this activity.
';
$string['removed']='Remove complete';
$string['remove_sentto']='Emails have been sent to the following people:';
$string['remove_notsentto']='For technical reasons, we were unable to send all the emails to inform people that they have been removed. You may wish to tell the following people yourself:';

// Legalese
$string['iagree_create']='I agree to accept the above responsibilities and wish to set up a shared activity';
$string['iagree_view']='I agree to the conditions above';
$string['agree_view_heading']='Shared activity agreement';
$string['agree_view']='
<p>
You have been invited to join a shared activity area.
</p>
<p>
The person who invited you to join this activity area is the owner and moderator 
of the area and has the right to remove content they deem inappropriate, and to 
remove your access to the area at any time if they so wish.
</p>
<p>
If you do not agree to this, please do not use the shared activities system.
</p>
';
$string['agree_create_heading']='Shared activity agreement';
$string['agree_create']='
<p>You have requested to set up a shared activity area. Please note that use of 
these tools is optional and people you invite are not 
obliged to participate if they do not wish to.</p>

<p>By initiating this activity area, you are agreeing to take responsibility for 
the administration of the area as owner and moderator - you agree to manage 
the membership of the area and the content which is added to the area.</p>
';

$string['leave_instructions']='
<p>
Once you leave an activity you will no longer be able to access it, unless the
activity owner invites you again.
</p>
<p>
Are you sure you want to leave the activity <strong>$a</strong>?
</p>
';

$string['delete_instructions']='
<p>
<strong>This action cannot be undone</strong>. When an activity has been 
deleted it is not possible to retrieve it. All information in the activity will 
be permanently lost.
</p>
<p>
Do you still want to delete the activity? .
</p>
';
$string['delete_gotparticipants']='
<p>
You cannot delete this activity yet because it still has participants. In order
to delete it, please first remove other members using <a href=\'$a\'>the
invite screen</a>.
</p> 
';

$string['edit']='Edit shared activity';
$string['edit_instructions']='
<p>
Make changes to the activity settings below.
</p>
<p>
If you have already invited 
people to your activity, be cautious about changing the name: a radically 
different name might cause confusion.
</p>
';

// Capabilities
$string['sharedactv:view']='View shared activities';
$string['sharedactv:create']='Create shared activities';
$string['sharedactv:manage']='Manage shared activities';
$string['sharedactv:viewother']='View all users\' shared activities';

$string['intro']='Welcome to the shared activities system, which lets you create
activities and share them with selected other people. These are not part of your 
formal course content. Two types of activity are currently
available: <strong>forums</strong> and (if installed in this system) 
<strong>OU wikis</strong>.';
$string['availableactivities']='available activity types';
$string['help']='If you need help with the system, click the appropriate ? 
help button, or view the <a href=\'$a\'>user guide</a>.';
