<?php
require_once(dirname(__FILE__).'/../../../config.php');
require_once(dirname(__FILE__).'/sharedactv.php');
global $CFG,$USER;

$course=sharedactv_get_magic_course();
$context=get_context_instance(CONTEXT_COURSE, $course->id);
require_login($course);

// Get user and (if you're trying to do it for somebody else) check that you
// have viewother capability
$userid=required_param('user',PARAM_INT);
$otheruser=$userid!=$USER->id;
if($otheruser) {
    require_capability('format/sharedactv:viewother',$context);    
    $user=get_record('user','id',$userid);
} else {
    $user=$USER;
}
$backurl='./'.($otheruser?'?user='.$userid : '');

// Check activity matches
$cmid=required_param('activity',PARAM_INT);
$cm=get_record('course_modules','id',$cmid);
if($cm->course!=$course->id) {
    error("Activity $cmid is not on shared-activity course",$backurl);
}

$info=sharedactv_get_activity_info($cmid);

// Process actual actions
if(isset($_POST['cancel'])) {
    redirect($backurl);
    exit;
} else if(isset($_POST['orly'])) {
    sharedactv_remove_participant($cmid,$userid);
    sharedactv_log($course,'leave',$cmid,
        $userid!=$USER->id ? 'As user: '.$userid : '');
    redirect($backurl);
    exit;    
}

// No actions, so display confirmation screen

// Display the header...
$strleave=get_string('removeme','format_sharedactv');
$nav=array();
$nav[]=array('name'=>$strleave,'type'=>'misc');
print_header($strleave,$strleave,build_navigation($nav,$cm));
sharedactv_ui_viewotherbar($user);    
print '<div class="sa_mainbit">';
print_heading_with_help($strleave,'leave','format_sharedactv');
print_string('leave_instructions','format_sharedactv',$info->name);

// ...the form...
$strcancel=get_string('cancel');
print <<<END
<form action="leave.php" method="post"><div>
<input type="hidden" name="activity" value="$cmid" />
<input type="hidden" name="user" value="$userid" />
<input type="submit" name="orly" value="$strleave" />
<input type="submit" name="cancel" value="$strcancel" />
</div></form>
END;
    
// ...and footer
print '</div>';
print_footer();

?>